﻿using OOO_WriteAndClear.DBModels;
using OOO_WriteAndClear.MVP.Models.OrderFormerer;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace OOO_WriteAndClear.MVP.MVPInterfaces
{
    public interface IOrderCartWindowContract
    {
        public interface IView
        {
            public string OrderCostWithoutDiscount { set; }
            public string OrderDiscount { set; }
            public string OrderCostWithDiscount { set; }

            public ICollection<OrderProduct> OrderList { set; }
        }

        public interface IPresenter
        {
            Order CurrentOrder { get; }


            void SetCurrentOrderFormerer(OrderFormerer orderFormerer);

            void AddProductUnitIntoOrder(string productArticle);

            void RemoveProductUnitFromOrder(string productArticle);

            void RemoveProductFromOrder(string productArticle);

            ICollection<PickupPoint> GetAllPickupPoints();

            void AddOrderInSystem(PickupPoint selectedPickupPoint);
        }

        public interface IModel
        {
            public OrderFormerer OrderFormerer { get; set; }


            void AddProductUnitIntoOrder(string productArticle);

            void RemoveProductUnitFromOrder(string productArticle);

            void RemoveProductFromOrder(string productArticle);

            ICollection<PickupPoint> GetAllPickupPoints();

            void AddOrderInSystem(PickupPoint selectedPickupPoint);
        }
    }
}
