﻿using OOO_WriteAndClear.DBModels;
using OOO_WriteAndClear.MVP.Models;
using OOO_WriteAndClear.MVP.Models.ProductsUserControlModel;
using OOO_WriteAndClear.MVP.MVPInterfaces;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace OOO_WriteAndClear.MVP.Presenters
{
    public class OrdersUserControlPresenter : IOrdersUserControlContract.Presenter
    {
        public OrdersUserControlPresenter(IOrdersUserControlContract.View view) 
        {
            _view = view;
            _model = new OrdersUserControlModel();
        }


        public ICollection<Order> Orders => _model.Orders;


        public void UpdateOrdersFromDB()
        {
            _model.UpdateOrdersFromDB();
        }

        public ICollection<Order> UpdateOrdersListForSortingAndFilting(FilterByDiscountParameters filterParams, string sortingParams)
        {
            _model.FilterAndSorting(filterParams, sortingParams);
            return _model.Orders;
        }


        private IOrdersUserControlContract.View _view;

        private IOrdersUserControlContract.Model _model;
    }
}
