﻿using OOO_WriteAndClear.DBModels;
using OOO_WriteAndClear.EventBus.Signals;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace OOO_WriteAndClear.MVP.Views
{
    /// <summary>
    /// Логика взаимодействия для FeaturesMenuUserControl.xaml
    /// </summary>
    public partial class FeaturesMenuUserControl : UserControl
    {
        public FeaturesMenuUserControl()
        {
            InitializeComponent();
            SetUserData();
        }


        private void SetUserData()
        {
            User user = (User)Application.Current.Resources["CurrentUser"];
            DisplayingUserName.Text = user.UserSurname 
                + " "
                + user.UserName
                + " "
                + user.UserPatronymic;
            DisplayingUserRole.Text = user.UserRoleNavigation.RoleName;
        }

        private void Exit_ButtonClick(object sender, RoutedEventArgs e)
        {
            EventBus.EventBus.GetService().Invoke(new BackToAuthorizationUserControlSignal());
        }

        private void GoToOrdersUserControl_ButtonClick(object sender, RoutedEventArgs e)
        {
            EventBus.EventBus.GetService().Invoke(new GoToOrdersUserControlSignal());
        }

        private void GoToProductsUserControl_ButtonClick(object sender, RoutedEventArgs e)
        {
            EventBus.EventBus.GetService().Invoke(new GoToProductsUserControlSignal());
        }
    }
}
